#!/usr/bin/env python2
# Copyright 2016 Tero Karvinen & Kimmo Karvinen http://BotBook.com
"BotBook.com Python IoT server. "

import sys
if sys.version_info[0]>2:       # require python2
	raise Exception("Python2 required! Current (wrong) version: '%s'" % sys.version_info)

import serial	# sudo apt-get -y install python3-serial # 
from time import sleep
from urllib import urlopen
#from urllib.error import HTTPError

def serReadLine(ser):
	s = ser.readline(500)
	assert type(s)==str

	if len(s)<=1:
		return None
	if not s.endswith('\n'):
		return 'ERROR: Serial: Unknown command "%s"' % s
	s = s.replace('\n', '');
	return s

def get(url):
	f = urlopen(url)
	return f.read()

def firstLine(s):
	return s.split('\n')[0]

def main():
	# port: "/dev/ttyUSB1", "COM1"
	ser = serial.Serial(port="/dev/ttyACM0", baudrate=115200, timeout=1)

	while True:
		s = serReadLine(ser)
		if s: 
			print(s)
			if s.startswith("HELLO"):
				ser.write(b'OK BotBookESP Python 0.0.1\n')
			elif s.startswith("GET"):
				# GET http://139.162.200.127/add/hw0ZcPe9p8Y/?x=2.6
				url=s.split()[1]
				body=get(url)
				body=firstLine(body)
				body=body.encode('ASCII')
				print(body.decode('ASCII'))
				ser.write(body)
			else:
				msg='ERROR: Python: unknown command "%s"' % s.replace('\n', '')
				ser.write(s)
		# ser.flushInput()
		sleep(0.2) # seconds

if __name__ == '__main__':
	main()


