// hc_sr04.ino - print distance to serial
// (c) BotBook.com - Karvinen, Karvinen, Valtokari

int trigPin = 8;
int echoPin = 7;
float v = 331.5 + 0.6 * 20; // m/s
int servoFrontPin = 2;


void setup()
{
  Serial.begin(115200);
  pinMode(trigPin, OUTPUT);	// <1>
  pinMode(echoPin, INPUT);	// <2>
  pinMode(servoFrontPin, OUTPUT);
}

void pulseServo(int servoPin, int pulseLenUs)
{
  digitalWrite(servoPin, HIGH);
  delayMicroseconds(pulseLenUs);
  digitalWrite(servoPin, LOW);
  delay(20);
}

void servoLeft()
{
  for (int i = 0; i <= 25; i++) {
    pulseServo(servoFrontPin, 2400);
  }

}

void servoCenter()
{
  for (int i = 0; i <= 25; i++) {
    pulseServo(servoFrontPin, 1500);
  }

}


int distanceCm() {
  // send sound pulse
  digitalWrite(trigPin, LOW);
  delayMicroseconds(3);
  digitalWrite(trigPin, HIGH);
  delayMicroseconds(5);
  digitalWrite(trigPin, LOW);

  // listen for echo
  float tUs = pulseIn(echoPin, HIGH); // microseconds
  float t = tUs / 1000.0 / 1000.0 / 2; // s
  float d = t * v; // m
  return d * 100; // cm
}

void loop()	// <3>
{
  int d = distanceCm();
  Serial.println(d, DEC);
  if (d > 15) {
    servoLeft();

  } else {
  servoCenter();
  }
}

